belledluxe/belleluxe/api/urls.py
from django.urls import path, include
from api import views
from rest_framework import routers
app_name = 'api'

router = routers.DefaultRouter()
router.register(r'campaign', views.CrudCampaign)
router.register(r'category', views.CrudCategory)
router.register(r'customer', views.CrudCustomer)
router.register(r'productos', views.CrudProductos)
router.register(r'itemPedido', views.CrudItemPedido)
router.register(r'pedido', views.CrudPedido)



urlpatterns=[
    #cruds
    path('cruds/', include(router.urls)),
    #tienda 
    path('tienda/productos/', views.ListaProductos.as_view(), name="api_tienda_producto"),
    #Cuenta
    path('registro/', views.RegistroAPI.as_view(), name="api_login"),
    path('csrf_cooky/', views.getcsrftoken.as_view(), name="api_token"),
    path('autenticacion/', views.CheckAuthenticatedView.as_view(), name="autenticacion" ),
    path('iniciar_sesion/', views.LoginView.as_view(), name="api_loginn"),
    path('cerrar_sesion/', views.LogoutView.as_view(), name="api_logout"),
    #Usuarios
    path('eliminar_usuario/', views.DeleteAccountView.as_view(), name = "deleteUser"),
    path('ver_usuarios/', views.GetUsersView.as_view(), name = "getUsers"),
    path('ver_usuario/', views.GetCustomerView.as_view(), name = "GetCus"),
    path('actualizar_user/', views.UpdateCustomerProfileView.as_view(), name = "UpdateUser"),
    #Pedidos
    path('ver_pedido/', views.verpedidoAPI.as_view(), name = "apiVerPedido"),
    path('crearpedido/', views.pedidoAPI.as_view(), name = "apiPedido"),

    


    
    ] 

belledluxe/belleluxe/belleluxe/urls.py
from django.contrib import admin
from django.urls import path, include
from home import views
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include("home.urls")),
    path('adm/', include("core.urls")),
    path('accounts/', include('django.contrib.auth.urls')),
    path('tienda/', include ("tienda.urls")),
    path('carrito/', include ("carrito.urls")),
    path('api/', include ("api.urls")),
    path('api-auth/', include('rest_framework.urls'))
]


if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

belledluxe/belleluxe/carrito/urls.py
from django.urls import path

from . import views

app_name = 'carrito'
 
urlpatterns = [
    path('', views.corder, name="order"),
    path('add/',views.carrito_add, name ="carrito_add"),
    # path('detail/carrito/<int:pk>/', views.DetailCarrito, name='detail_carrito'),
    path('update/', views.UpdateCarrito, name='update_carrito'),
    path('delete/', views.DeleteCarrito, name='delete_carrito'),
    path('pago/', views.pagoos.as_view(), name='pagoC'),
    path('pedidos/', views.verPedidos.as_view(), name='pedidos'),


]

belledluxe/belleluxe/home/urls.py
from django.contrib import admin
from django.urls import path, include
from home import views


app_name="home"
urlpatterns=[
    path('', views.inicio.as_view(), name="inicio"),
    path('nosotros/', views.nosotros.as_view(), name="nosotros"),
    path('blog/', views.blog.as_view(), name="blog"),
    path('servicios/', views.servicios.as_view(), name="servicios"),
    path('politicas/', views.politicas.as_view(), name="politicas"),
    path('perfil/<int:pk>/', views.perfil.as_view(), name="perfil"),

# Accesos
    path('registro/', views.registrar.as_view(), name='registro'),
    path('acceso/', views.Acceso.as_view(), name='acceso'),
    path('cierre/',views.cierre, name='cierre'),
    path('perfil/actualiar/<int:pk>/', views.UpdateProfile.as_view(), name="actualizarPerfil"),

]

belledluxe/belleluxe/tienda/urls.py
from django.contrib import admin
from django.urls import path
from tienda import views


#  Compras 
app_name= "tienda"
urlpatterns=[
    path('', views.tienda.as_view(), name="tienda"),
    path('hombre/', views.hombre.as_view(), name="hombre"),
    path('mujer/', views.mujer.as_view(), name="mujer"),
    path('producto/<int:pk>/', views.producto.as_view(), name='producto'),
    path('categoria/<int:pk>/', views.Pcategoria.as_view(), name='Pcategoria'),
    path('busqueda/', views.busqueda.as_view(), name='busqueda'),
]

belledluxe/belleluxe/core/models.py
from audioop import reverse
from django.db import models
from django.contrib.auth.models import User
from django.dispatch import receiver
from django.db.models.signals import post_save

TipoGenero=(("Hombre","Hombre"),("Mujer","Mujer"))

class campaign(models.Model):
    lasteditor = models.ForeignKey(User, on_delete=models.CASCADE)
    name=models.CharField(max_length=30, default='generico')
    year=models.DateField(auto_now_add=True)
    def __str__(self):
        return self.name



class Category(models.Model):
    lasteditor = models.ForeignKey(User, on_delete=models.CASCADE)
    name=models.CharField(max_length=25, default='generic category')
    
    class Meta:
        verbose_name_plural = 'categories'
    def get_absolute_url(self):
        return reverse('core:category', args=[str(self.name)])
    def __str__(self):
        return self.name



class Customer(models.Model):
    user = models.OneToOneField(User, on_delete=models.CASCADE)
    name_first=models.CharField(max_length=35)
    last_name_pat=models.CharField(max_length=25)
    last_name_mat=models.CharField(max_length=25, blank=True, null=True)
    phone=models.CharField(max_length=15)
    cp=models.CharField(max_length=5)
    streat=models.CharField(max_length=25)
    number_home=models.CharField(max_length=5)
    def __str__(self):
        return self.name_first


        

#Agregar un max_length al stock
class Product(models.Model):
    lasteditor = models.ForeignKey(User, on_delete=models.CASCADE)
    name=models.CharField(max_length=35)   
    campaign=models.ForeignKey(campaign, on_delete=models.CASCADE)
    gender=models.CharField(max_length=10, choices=TipoGenero)
    category=models.ForeignKey(Category, on_delete=models.CASCADE)
    description=models.CharField(max_length=256)
    size=models.CharField(max_length=4)
    price=models.FloatField(default=0.0)
    status=models.BooleanField(default=False)
    stock=models.IntegerField(default=0)
    slug=models.SlugField(max_length=36)
    imagen1 = models.ImageField(upload_to='media/', null=True) 

    
    class Meta:
        verbose_name_plural = 'Products'
        ordering = ('-status',)

    def get_absolute_url(self):
        return reverse('core:product', args=[self.slug])
    
    def __str__(self):
        return self.name

class ItemPedido(models.Model):
    pedido = models.ForeignKey('Pedido', on_delete=models.CASCADE)
    product = models.ForeignKey(Product, on_delete=models.CASCADE)
    cantidad = models.PositiveIntegerField()
    codigo_producto = models.CharField(max_length=20, unique=True) 


class Pedido(models.Model):
    usuario = models.ForeignKey(User, on_delete=models.CASCADE)
    productos = models.ManyToManyField(Product, through=ItemPedido)
    fecha = models.DateTimeField(auto_now_add=True)
    codigo_pedido = models.CharField(max_length=20, unique=True)

belledluxe/belleluxe/carrito/views.py
from django.http import JsonResponse
from decimal import FloatOperation
from django.contrib.auth.mixins import LoginRequiredMixin
from django.shortcuts import get_object_or_404, render, redirect
from django.db import transaction
from django.utils.crypto import get_random_string
from django.views import generic
from django.urls import reverse_lazy

# Create your views here.

from core.models import Product, ItemPedido, Pedido
from .carrito import Carrito


def corder(request):
    carrito = Carrito(request)

    data = []
    for item in carrito:
        product = item['product']
        stock = product.stock
        qty_range = range(1, product.stock + 1)
        data.append({'item': item, 'qty_range': qty_range})
        #print(f'Item: {item}, Qty Range: {list(qty_range)}')
        
    #print(f'data: {data}')
    return render(request, 'carrito/corder.html', {'data': data})

 
def carrito_add(request):

    carrito = Carrito(request)

    if request.method == 'POST' and request.POST.get('action') == 'post':
        try:
            product_id = int(request.POST.get('productId'))
            product_qty = int(request.POST.get('productQty'))
        except (ValueError, TypeError):
            # Manejar errores si 'productId' o 'productQty' no son números enteros
            return JsonResponse({'error': 'Invalid data'}, status=400)

        try:
            product = Product.objects.get(id=product_id)
        except Product.DoesNotExist:
            return JsonResponse({'error': 'Product not found'}, status=404)

        # Asegura de que el producto y la cantidad sean válidos antes de agregar al carrito
        if product and product_qty > 0:
            carrito.add(product=product, qty=product_qty)
            
            carrito_qty = carrito.__len__()
            response = JsonResponse({'qty': carrito_qty})
            return response

    # si no es una solicitud POST válida
    return JsonResponse({'error': 'Invalid request'}, status=400)



def DeleteCarrito(request):
    carrito = Carrito(request)
    if request.POST.get('action') == 'post':
        product_id = int(request.POST.get('productId'))
        carrito.delete(product=product_id)

        carritoQty = carrito.__len__()
        carritoTotal = carrito.get_total_price()
        response = JsonResponse({'qty': carritoQty, 'subtotal': carritoTotal})
        return response


def UpdateCarrito(request):
    carrito = Carrito(request)
    if request.POST.get('action') == 'post':
        product_id = int(request.POST.get('productId'))
        product_qty = int(request.POST.get('productQty'))
        carrito.update(product=product_id, qty=product_qty)

        carritoQty = carrito.__len__()
        carritoTotal = carrito.get_total_price()
        response = JsonResponse({'qty': carritoQty, 'subtotal': carritoTotal})
        return response



class pagoos(LoginRequiredMixin,generic.View):
    template_name = "carrito/pago.html"
    context={}
    login_url = reverse_lazy("home:acceso")
    def get(self, request):
        self.context = {
        }
        return render(request, self.template_name, self.context)
    def post(self, request):

        carrito = Carrito(request)

            # Procesar el formulario y realizar el pago (puede ser una integración con un proveedor de pagos)
            # Si el pago es exitoso, guarda la orden en la base de datos
        with transaction.atomic():
                # Crea un nuevo pedido en la base de datos
            pedido = Pedido.objects.create(usuario=request.user, codigo_pedido=get_random_string(length=8))

                # Añade los productos al pedido
            for product_id, item in carrito.carrito.items():
                product = Product.objects.get(id=int(product_id))
                cantidad = item['qty']
                codigo_producto = get_random_string(length=8)

                ItemPedido.objects.create(pedido=pedido, product=product, cantidad=cantidad, codigo_producto=codigo_producto)

                    # Actualiza el stock del producto
                product.stock -= cantidad
            product.save()

            # Limpia el carrito después de procesar la orden
            carrito.carrito.clear()
            carrito.save()

            # Renderiza la página de confirmación
            return render(request, 'carrito/pedido.html', {'pedido': pedido})
        

class verPedidos(LoginRequiredMixin, generic.View):
    template_name="carrito/verpedidos.html"
    context={}
    login_url = reverse_lazy("home:acceso")
    def get(self, request):
        pedidos=Pedido.objects.filter(usuario=request.user)
        self.context={
            "pedidos":pedidos
        }
        return render(request, self.template_name, self.context)
    

belledluxe/belleluxe/templates/carrito/corder.html
{% extends 'base/desprod.html' %}
{% load static %}
{% block title %}Carrito de Compras{% endblock %}


{% block content %}

<style>
   #btn1{
       background-color: #000000;
      border: 1px solid rgb(255, 255, 255);
       color: rgb(255, 255, 255);
       padding: 10px 60px;
       text-align: center;
       text-decoration: none;
       display: inline-block;
       font-size: 16px;
       margin-left: 5%;
       cursor: pointer;
       border-radius: 30px;
       
     }

</style>


<main class="pt-5">
  <div class="container">
    <p id="carrito" style="font-size: 350%; padding-top:4%; padding-bottom: 5%;">Carrito de compras</p>

    {% for item in carrito %}
      {% with product=item.product %}
      <div id="itzzzz" data-index="{{product.id}}" class="row mb-4 border product-item"  style="padding: 7%;">
        <div class="col-md-3 order-md-first ">
          <img  class="img-fluid mx-auto d-block"  src="{{ product.imagen1.url }}">
        </div>
        <div class="col-md-4 col-lg-8 ">
          <a href="{% url 'tienda:producto' product.id %}" class="text-decoration-none text-reset">
            <h1 class="h5 pt-2" style="padding-left: 6%; padding-bottom: 2%;">{{ product.name }}</h1>
          </a>
          <div class="border" style="margin-left: 6%;">
            <div class="col border-bottom">
              <div class="row p-3">
                <div class="col-6">Precio por unidad :</div>
                <div class="col-6 text-end"><span class="h6 fw-bold">$ {{ product.price }}</span></div>
              </div>
            </div>
            <div class="col">
              <div class="row p-3">
                <div class="col-12">
                  <label for="select">Cantidad</label>
                  <select id="select{{product.id}}">
                    <option selected>
                      {{ item.qty }}
                    </option>  
                    {% for item in data %}
                      {% for i in item.qty_range %}
                        <option value="{{ i }}" {% if i == item.item.qty %}selected{% endif %}>
                          {{ i }}
                        </option>
                      {% endfor %}
                  {% endfor %}
                  </select>
                  <button type="button" id="update-button" data-index="{{product.id}}"
                    class="btn btn-outline-secondary btn-sm update-button">
                    Actualizar
                  </button>
                  <button type="button" id="delete-button" data-index="{{product.id}}"
                    class="btn btn-outline-secondary btn-sm delete-button">
                    Borrar
                  </button>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
      {% endwith %}
    {% endfor %}
    <a id="btn1" href="{% url 'tienda:tienda'%}" class="btn btn-info" role="button">Regresar</a>
    <div class="col-12 text-end">
      
      <div class="h6 fw-bold">Sub Total: $ <div id="subtotal" class="d-inline-flex">{{ carrito.get_total_price }}</div></div>
      <a id="btn1" href="{% url 'carrito:pagoC'%}" class="btn btn-dark">Pagar</a>
    </div>
  </div>
</main>

<script>
  // Borrar producto 
  $(document).on('click', '.delete-button', function (e) {
    e.preventDefault();
    var prodid = $(this).data('index');
    $.ajax({
      type: 'POST',
      url: '{% url "carrito:delete_carrito" %}',
      data: {
        productId: $(this).data('index'),
        csrfmiddlewaretoken: "{{csrf_token}}",
        action: 'post'
      },
      success: function (json) {
        $('.product-item[data-index="' + prodid + '"]').remove();
        document.getElementById("subtotal").innerHTML = json.subtotal;
        document.getElementById("carrito-qty").innerHTML = json.qty
      },
      error: function (xhr, errmsg, err) {}
    });
  })

  // Actualizar carrito 
  $(document).on('click', '.update-button', function (e) {
    e.preventDefault();
    var prodid = $(this).data('index');
    $.ajax({
      type: 'POST',
      url: '{% url "carrito:update_carrito" %}',
      data: {
        productId: $(this).data('index'),
        productQty: $('#select' + prodid + ' option:selected').text(),
        csrfmiddlewaretoken: "{{csrf_token}}",
        action: 'post'
      },
      success: function (json) {
        document.getElementById("carrito-qty").innerHTML = json.qty
        document.getElementById("subtotal").innerHTML = json.subtotal
      },
      error: function (xhr, errmsg, err) {}
    });
  })
</script>
{% endblock %}

belledluxe/belleluxe/templates/carrito/pago.html
{% extends 'base/logsing.html' %}
{% load static %}
{% block title %}Carrito de Compras{% endblock %}

{% block content %}
<style>

  .btn-sample { 
      color: #FFFFFF; 
      background-color: #364361; 
      border-color: #FFFFFF; 
    } 
     
    .btn-sample:hover, 
    .btn-sample:focus, 
    .btn-sample:active, 
    .btn-sample.active, 
    .open .dropdown-toggle.btn-sample { 
      color: #FFFFFF; 
      background-color: #2A3245; 
      border-color: #FFFFFF; 
    } 
     
    .btn-sample:active, 
    .btn-sample.active, 
    .open .dropdown-toggle.btn-sample { 
      background-image: none; 
    } 
     
    .btn-sample.disabled, 
    .btn-sample[disabled], 
    fieldset[disabled] .btn-sample, 
    .btn-sample.disabled:hover, 
    .btn-sample[disabled]:hover, 
    fieldset[disabled] .btn-sample:hover, 
    .btn-sample.disabled:focus, 
    .btn-sample[disabled]:focus, 
    fieldset[disabled] .btn-sample:focus, 
    .btn-sample.disabled:active, 
    .btn-sample[disabled]:active, 
    fieldset[disabled] .btn-sample:active, 
    .btn-sample.disabled.active, 
    .btn-sample[disabled].active, 
    fieldset[disabled] .btn-sample.active { 
      background-color: #364361; 
      border-color: #FFFFFF; 
    } 
     
    .btn-sample .badge { 
      color: #364361; 
      background-color: #FFFFFF; 
    }
</style>
<script src="http://netdna.bootstrapcdn.com/bootstrap/3.0.0/js/bootstrap.min.js"></script>
<link href="http://netdna.bootstrapcdn.com/bootstrap/3.0.0/css/bootstrap.min.css" rel="stylesheet"/>
<center>
<div class="card" style="width: 40rem;">
  <div class="card-body">
<br>
<form method="post">
  {% csrf_token %}
    <label for="fname">Número de tarjeta:</label><br>
    <input type="text" id="fname" name="fname" class="form-control" maxlength="16" placeholder="8888 8888 8888 8888"><br>
    <label for="lname">Fecha de expiración:</label><br>
    <div class="row">
      <div class="col-xs-6">
        <input type="text" class="form-control" placeholder="mes" maxlength="2" /> 
      </div>
      <div class="col-xs-6">
        <input type="text" class="form-control" placeholder="años" maxlength="2" /> 
     </div>
    </div>
    <br>
   <div class="input-group">
    <label for="lname" >CVV:</label><br>
    <input type="password" maxlength="3" id="lname" name="lname" class="form-control">
   </div>
   <br>
   <button type="submit" class="btn btn-sample " >Pagar</button>
    <a href="{% url 'home:inicio' %}" class="btn btn-dark">Volver</a>
</form>
<br>

<br>

</div>
</div>
</center>



{% endblock content %}

belledluxe/belleluxe/templates/carrito/pedido.html
{% extends 'base/principal.html' %}
{% load static %}

{% block title %}Pedido{% endblock %}

{% block content %}
<main class="pt-5">
  <div class="container">
    <div class="row">
      <div class="col-md-8 offset-md-2">
        <div class="card">
          <div class="card-body">
            <h2 class="card-title">Gracias por su compra:</h2>
            <p class="card-text">A continuación, se muestra la información del pedido:</p>
            
            <p><strong>Código de Pedido:</strong> {{ pedido.codigo_pedido }}</p>
            <p><strong>Fecha del Pedido:</strong> {{ pedido.fecha }}</p>
            
            <h2 class="mt-4">Productos del Pedido:</h2>
            <ul class="list-group">
              {% for item in pedido.itempedido_set.all %}
                <li class="list-group-item">{{ item.product.name }} - Cantidad: {{ item.cantidad }}</li>
              {% endfor %}
            </ul>
            <a href="{% url 'home:inicio' %}" class="btn btn-dark mt-4">Volver al inicio</a>
          </div>
        </div>
      </div>
    </div>
  </div>
</main>
{% endblock %}

belledluxe/belleluxe/templates/carrito/verpedidos.html
{% extends 'base/logsing.html' %}
{% load static %}

{% block title %}Pedidos{% endblock %}

{% block content %}
<main class="pt-5">
  <div class="container">
    <div class="row justify-content-center">
      <div class="col-md-8">
        {% if pedidos %}
          <h2 class="mb-4">Lista de Pedidos:</h2>
          {% for pedido in pedidos %}
            <div class="card mb-4">
              <div class="card-body">
                <h5 class="card-title">Código de Pedido: {{ pedido.codigo_pedido }}</h5>
                <p class="card-text"><strong>Fecha del Pedido:</strong> {{ pedido.fecha }}</p>

                <h6 class="mt-3">Productos del Pedido:</h6>
                <ul class="list-group">
                  {% for item in pedido.itempedido_set.all %}
                    <li class="list-group-item">{{ item.product.name }} - Cantidad: {{ item.cantidad }}</li>
                  {% endfor %}
                </ul>
              </div>
            </div>
          {% endfor %}
        {% else %}
          <div class="alert alert-info" role="alert">
            <h4 class="alert-heading">No tiene ningún pedido</h4>
            <p>Realice una compra para ver sus pedidos aquí.</p>
          </div>
        {% endif %}
        
        <a href="{{ request.META.HTTP_REFERER }}" class="btn btn-dark mt-3">Volver</a>
      </div>
    </div>
  </div>
</main>
{% endblock %}